#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

typedef struct vec_int_st {
  int* eles;
  size_t length;
} vec_int;

bool vec_push(vec_int* vec, int to_push);

int main() {
  vec_int my_vec = (vec_int) {
    .eles = NULL,
    .length = 0U,
  };

  vec_push(&my_vec, 3);
  vec_push(&my_vec, 8);
  vec_push(&my_vec, 0);
  vec_push(&my_vec, 0);

  for (size_t i = 0; i < my_vec.length; i++) {
    printf("%d\n", my_vec.eles[i]);
  }
}

bool vec_push(vec_int* vec, int to_push) {
  /* with malloc()
  int* new_eles = malloc((vec->length + 1) * sizeof(int));
  if (new_eles == NULL) {
    return false;
  }

  for (size_t i = 0; i < vec->length; i++) {
    new_eles[i] = vec->eles[i];  
  }

  free(vec->eles);
  vec->eles = new_eles;
  vec->eles[vec->length] = to_push;
  vec->length = vec->length + 1;
  return true;
  */
  int* new_eles = realloc(vec->eles, sizeof(int) * (vec->length + 1));

  if (new_eles == NULL) {
    return false;
  }
  vec->eles = new_eles;
  vec->eles[vec->length] = to_push;
  vec->length = vec->length + 1;

  return true;
}
